// jQuery plugin for planscalendar functions

jQuery.planscalendar = function( options ) {

}


jQuery.planscalendar.current_calendar_being_edited = null;
jQuery.planscalendar.number_of_calendars_waiting_for_approval = 0;
jQuery.planscalendar.pending_calendars = 0;

// always called when the calendar page is done loading
jQuery.planscalendar.plans_page_loaded = function()  {
	jQuery.planscalendar.update_login();
	jQuery.planscalendar.map_cal_ids();

	// highlight current day
	var d = new Date();
	var timestamp = Math.floor((d.getTime() - d.getUTCMilliseconds() - d.getUTCSeconds() *1000 - d.getUTCMinutes() * 60000 - d.getUTCHours() * 3600000)/1000);
	$j('td[date='+timestamp+']').addClass('today');
	$j('td[date='+timestamp+'] .date').addClass('today');

	// hook up add/edit event click
	var f = function(e, ui) {

		if ( e.target != $j('#menu_tabs')[0] ) {
			//unexpected target - ignore
			return
		}

		if (ui.index == 1) {
			jQuery.planscalendar.show_add_edit_event_dialog();
			jQuery.planscalendar.show_edit_event_dialog();
			jQuery.planscalendar.populate_add_edit_event_dialog({});
			return true;
		} else if (ui.index == 2) {
			jQuery.planscalendar.show_add_edit_calendar_dialog();
			return true;
		}
		return true;
	};

	menu_tabs = $j('#menu_tabs').tabs( {'selected':0});

	$j('#menu_tabs').bind( 'tabsselect', f );


	// init context menus
	$j('#day_contextmenu_add_event').html(plans_lang['add_event_on_this_day']);
	$j('#event_contextmenu_edit_event').html(plans_lang['context_menu_edit_event']);
	$j('#event_contextmenu_clone_event').html(plans_lang['context_menu_clone_event']);
	$j('#event_contextmenu_delete_event').html(plans_lang['context_menu_delete_event']);

	jQuery.planscalendar.hookup_contextmenu_events();	

	// setTimeout to prevent delay on page load	
	setTimeout(jQuery.planscalendar.insert_lang_strings,100);

	jQuery.planscalendar.update_calendar_controls();
		
	if (messages != null && messages != '') jQuery.planscalendar.update_messages(messages);
	  
}

jQuery.planscalendar.update_calendar_controls = function() {

	$j('form[name=tab0_form]').attr('action', plans_url);

	$j('#cal_start_month').empty();
	for (var i=0;i<plans_lang['months'].length;i++) {
		$j('#cal_start_month').append('<option value="' + i  + '">' + plans_lang['months'][i] + '</option>');
	}

	$j('#cal_start_month option[value=' + jQuery.planscalendar.calendar_controls.cal_start_month + ']').attr('selected','selected');

	$j('#cal_start_year').val(jQuery.planscalendar.calendar_controls.cal_start_year);
	$j('#cal_num_months').val(jQuery.planscalendar.calendar_controls.cal_num_months);

}

jQuery.planscalendar.map_cal_ids = function()  {
	
	jQuery.planscalendar.cal_ids = {};

	for (var i=0;i<jQuery.planscalendar.calendars.length;i++) {
		jQuery.planscalendar.cal_ids[''+jQuery.planscalendar.calendars[i].id] = jQuery.planscalendar.calendars[i];
	}
}

jQuery.planscalendar.get_cal = function(cal_id)  {
	return jQuery.planscalendar.cal_ids[''+cal_id];
}

jQuery.planscalendar.calendars = [];
jQuery.planscalendar.events = {};

var help_text = '';

var Temp = new Object;

var plans_options = new Array();

var active_event_id = "";
var active_series_id = "";
var active_day_timestamp = "";
var current_calendar_id = "";
var dialog_box = null;

var info_window = new Object;
var info_window_width = 400;
var info_window_height = 400;

var plans_url = '';
var theme_url = '';
var css_path = '';

var event_target = null;
var browser_type = null;
var cal_password = '';

var logged_in = false;

var pending_events = [];
var users = new Array();
var current_user = null;

var success = false;
var messages = "";

var menu_tabs = null;

var jgrowl_opts = {
                    theme: 'manilla',
                    sticky: true,
                    speed: 'slow',
                    easing: 'easeInOutExpo',
                    animateOpen: {
                        height: "show",
                        width: "show"
                    },
                    animateClose: {
                        height: "hide",
                        width: "show"
                    }

};

function info(d) {try{console.info(d)}catch(e){}};


jQuery(window).bind('load', jQuery.planscalendar.plans_page_loaded);
// this should always be called by <body onunload=

function page_unloaded()  {
  if (info_window.close)
    {info_window.close();}
}

jQuery.planscalendar.insert_lang_strings = function() {
	for (key in {'controls_change':''} ) {
		$j('input[type=submit].lang_'+key).val(plans_lang[key]).empty();
	}

	for (key in plans_lang) {
		$j('.lang_'+key).html(plans_lang[key]);
	}

	$j('.help_text').html(plans_lang['help_on_this']);

}

jQuery.planscalendar.insert_lang_string = function( el, strings ) {

	for (var i=0;i< strings.length;i++) {
		var key = strings[i];
		$j('.lang_'+key).html(plans_lang[key]);
	}

}



jQuery.planscalendar.hookup_contextmenu_events = function() {
	// hook up context menu actions for days
	var days = $j('td.day');

	days.each(function(i){
		$j(this).contextMenu('day_contextmenu', {
			bindings:{
				'day_contextmenu_add_event':function(t) {
					$j('#menu_tabs').tabs('select',1);
					$j('a[href=#menu_tab_1] span').html(plans_lang.tab_text[1]);

					jQuery.planscalendar.show_add_edit_event_dialog();
					jQuery.planscalendar.populate_add_edit_event_dialog({});

					// populate add_edit_event data
					var timestamp = $j(t).attr('date');
					var d = new Date( );
					d.setTime( timestamp * 1000 );
					$j('#add_edit_event_start_date').val(formatDate(d, jQuery.planscalendar.date_format.replace(/mm/,'MM')));

				}
			}
		});
	});
	
	// hook up context menu actions for events
	var event_els = $j('.event_box');

	event_els.each(function(i){
		$j(this).contextMenu('event_contextmenu', {
			bindings:{
				'event_contextmenu_edit_event':function(t) {
					$j('#menu_tabs').tabs('select',1);

					jQuery.planscalendar.show_add_edit_event_dialog();
					jQuery.planscalendar.show_edit_event_dialog();
					jQuery.planscalendar.populate_add_edit_event_dialog(jQuery.planscalendar.events[$j(t).attr('event_id')]);
					$j('a[href=#menu_tab_1] span').html(plans_lang.tab_text[1]);
				},
				'event_contextmenu_clone_event':function(t) {
					$j('#menu_tabs').tabs('select',1);
					$j('a[href=#menu_tab_1] span').html(plans_lang.add_or_edit2);

					jQuery.planscalendar.show_add_edit_event_dialog();
					jQuery.planscalendar.populate_add_edit_event_dialog(jQuery.planscalendar.events[$j(t).attr('event_id')]);
					$j('#add_edit_event_id').val('');
					
				},
				'event_contextmenu_delete_event':function(t) {
					active_event_id = $j(t).attr('event_id');
					active_series_id = $j(t).attr('series_id');
					delete_event(t);
				}
			}
		});
	});


}

jQuery.planscalendar.show_add_edit_calendar_dialog = function() {
	info('show_add_edit_calendar_dialog');

	jQuery.planscalendar.current_calendar_being_edited = null;
	
	$j('#choose_calendar').show();	
	$j('#edit_calendar').hide();

	var menu_tabs_el = $j('#menu_tabs ul');
	var c = menu_tabs_el.offset();
	c.height = menu_tabs_el.height();
	c.width = menu_tabs_el.width();

	var w = $j('#calendar_area').width();
	var c2 = $j('#calendar_area').offset();


	$j('.ui-dialog.add_edit').css({'height':'auto'});
	$j('#add_edit_calendar_dialog').css({'height':'auto'});

	// populate calendar select

	$j('#edit_calendar_cal_id').empty();
	for (var i=0;i<jQuery.planscalendar.calendars.length;i++) {
		var calendar = jQuery.planscalendar.calendars[i];
		$j('#edit_calendar_cal_id').append('<option value="' + calendar.id  + '">' + calendar.title + '</option>');
	}

	$j('#choose_calendar_link').bind('click',jQuery.planscalendar.edit_calendar);
	$j('#add_new_cal_link').bind('click',jQuery.planscalendar.add_calendar);
	$j('#add_new_ical_link').bind('click',jQuery.planscalendar.add_ical);
	$j('#view_pending_calendars_link').bind('click',jQuery.planscalendar.view_pending_calendars);

	jQuery.planscalendar.update_pending_calendars_text();


}

jQuery.planscalendar.update_pending_calendars_text = function() {
	var num_pending_calendars = jQuery.planscalendar.pending_calendars.length;

	var text = get_lang('tab2_no_new_calendars');

	if (num_pending_calendars > 0 ) {
		text = get_lang('tab2_some_new_calendars').replace('###num###', num_pending_calendars);
	}

	$j('#pending_calendars_status').html(text);

}

jQuery.planscalendar.view_pending_calendars = function() {

	var contents = '';

	for (var i=0;i<jQuery.planscalendar.pending_calendars.length;i++) {
		var pending_calendar = jQuery.planscalendar.pending_calendars[i];
		contents += tmpl('pending_calendar_tmpl', pending_calendar);
	}

	contents += '<br style="clear:both"/>';

	contents += '<div class="form_field">';
	contents += '<label class="required" style="width:50%" for="main_password">';
	contents += jQuery.planscalendar.get_cal('0').title + ' ' + get_lang('password');
	contents += '</label>';
	contents += '<input type=password id="main_password" name = "main_password" size=10>';
	contents += '</div>';

	contents += '<div class="form_field">';
	contents += '<label style="width:50%">&nbsp</label>';
	contents += '<input id="approve_cal_button" type=submit name="approve_cal_button" value = "'+get_lang('view_pending_calendars5')+'">';
	contents += '</div>';


	$j('#pending_calendars_dialog').dialog('destroy');

	var w = $j('.calendar_controls').width();
	var c2 = $j('.calendar_controls').offset();

	$j('#pending_calendars_dialog').attr('title',get_lang('view_pending_calendars1')).html(contents).dialog({'resizable':true}).show();

	$j('#pending_calendars_dialog').css({'width':w,'height':'445px','overflow-x':'hide','overflow-y':'scroll'});
	$j('#pending_calendars_dialog').parents('.ui-dialog').css({width:w,left:c2.left,height:'500px'});

	$j('#approve_cal_button').click(jQuery.planscalendar.approve_delete_calendars_submit);

}

jQuery.planscalendar.approve_delete_calendars_submit = function() {

	var url = plans_url;

	var data = {
		'api_command':'approve_delete_pending_calendars',
		'main_password':$j('#main_password').val()
		};

	var approve_delete_radio_inputs = $j('.approve_delete_inputs input[type=radio]');
	info(approve_delete_radio_inputs);

	approve_delete_radio_inputs.each( function(i) {
		if (this.checked) {
			data[this.name] = this.value;
		}
	} );

	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			info('success!');

			jQuery.planscalendar.update_calendars(jsondata.calendars);
			jQuery.planscalendar.update_pending_calendars(jsondata.pending_calendars);
			jQuery.planscalendar.update_pending_calendars_text();

			jQuery.planscalendar.view_pending_calendars();

		}
	}

	$j('#approve_cal_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Please Wait...</span>'
	});

	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});


}

jQuery.planscalendar.update_calendars = function(updated_calendars) {
	jQuery.planscalendar.calendars = updated_calendars;

	jQuery.planscalendar.map_cal_ids();

	if ( jQuery.planscalendar.current_calendar_being_edited ) {
		// reset reference to current calendar
		jQuery.planscalendar.current_calendar_being_edited = jQuery.planscalendar.get_cal(jQuery.planscalendar.current_calendar_being_edited.id);
	}


}

jQuery.planscalendar.update_pending_calendars = function(updated_pending_calendars) {
	jQuery.planscalendar.pending_calendars = updated_pending_calendars;
}


jQuery.planscalendar.add_calendar = function() {
	$j('#del_cal_button').hide();
	$j('#delete_note').hide();
	$j('#edit_calendar_password_interface').hide();
	$j('#add_calendar_password_interface').show();
	$j('#user_no_add').show();

	if (jQuery.planscalendar.logged_in) {
		$j('#add_calendar_cal_password_field').hide();
	}else {
		$j('#add_calendar_cal_password_field').show();
	}


	jQuery.planscalendar.add_edit_calendar();

	jQuery.planscalendar.populate_add_edit_calendar_dialog( {} );
}


jQuery.planscalendar.edit_calendar = function() {

	var cal_id = $j('#edit_calendar_cal_id :selected').val();
	jQuery.planscalendar.current_calendar_being_edited = jQuery.planscalendar.get_cal(cal_id);

	$j('.lang_add_calendar').html(get_lang('edit_calendar') + ': ' + jQuery.planscalendar.current_calendar_being_edited.title);

	jQuery.planscalendar.populate_add_edit_calendar_dialog( jQuery.planscalendar.current_calendar_being_edited );

	$j('#del_cal_button').show();
	$j('#delete_note').show();
	$j('#edit_calendar_password_interface').show();
	$j('#add_calendar_password_interface').hide();
	$j('#user_no_add').hide();

	if (jQuery.planscalendar.logged_in) {
		$j('#edit_calendar_cal_password_field').hide();
	}else {
		$j('#edit_calendar_cal_password_field').show();
	}



	jQuery.planscalendar.add_edit_calendar();

}


jQuery.planscalendar.add_edit_calendar = function() {

	var w = $j('#menu_tabs').width();

	$j('#choose_calendar').hide();	
	$j('#edit_calendar').show();	
	$j('.ui-dialog.add_edit').css({'height':'auto'});

	if ( plans_options['users'] != 1 ) {
		//$j('#add_edit_calendar_tabs li').eq(4).hide();
	}

	$j('#add_edit_calendar_tabs').tabs({'selected':0});

	var f = function(e, ui) {
		info('calendar f!');
		info(e);
		info(ui);
		return false;
	}

	$j('#update_cal_button').val(get_lang('update_cal_button'));
	$j('#add_cal_button').val(get_lang('add_calendar'));
	$j('#del_cal_button').val(get_lang('del_cal_button1'));
	$j('#update_cal_button').bind('click',jQuery.planscalendar.add_edit_calendar_submit);
	$j('#add_cal_button').bind('click',jQuery.planscalendar.add_edit_calendar_submit);
	$j('#del_cal_button').bind('click',jQuery.planscalendar.delete_calendar_submit);



}

jQuery.planscalendar.populate_add_edit_calendar_dialog = function( calendar ) {

	info(calendar);
	$j('#date_format').val(calendar.date_format || jQuery.planscalendar.date_format);

	$j('#add_edit_calendar_cal_title').val(calendar.title || '');
	$j('#add_edit_calendar_cal_link').val(calendar.link || '');
	$j('#add_edit_calendar_details').val(calendar.details || '');


	// locally merged calendars
	$j('#background_calendars').empty();
	for (var i=0;i<jQuery.planscalendar.calendars.length;i++) {
		var c = jQuery.planscalendar.calendars[i];
		$j('#background_calendars').append('<option value="' + c.id  + '">' + c.title + '</option>');
		if ( calendar.local_background_calendars[''+c.id] == 1 ) {
			info('found a background calendar!');
			$j('#background_calendars option[value='+c.id+']').attr('selected','selected');
;
		}
	}
	//$j('#background_calendars').focus();

	if (plans_options.all_calendars_selectable == 1 ) {
		$j('#some_calendars_selectable').hide();
	} else {
		$j('#all_calendars_selectable').hide();
	}

	// week start day
	$j('#week_start_day').empty();
	for (var i=0;i<plans_lang.day_names.length;i++) {
		$j('#week_start_day').append('<option value="' + i  + '">' + plans_lang.day_names[i] + '</option>');

	}
	$j('#week_start_day option[value=' + calendar.week_start_day + ']').attr('selected','selected');

	$j('#default_number_of_months').val(calendar.default_number_of_months || '');
	$j('#max_number_of_months').val(calendar.max_number_of_months || '');
	$j('#gmtime_diff').val(calendar.gmtime_diff || '');
	$j('#event_change_email').val(calendar.event_change_email || '');

	// populate background colors dropdown
	var background_colors_html = '';
	background_colors_html += '<option style="background-color:#fff;" value="">None</option>';
	for( var i=0;i<event_background_colors.length;i++) {
		var color = event_background_colors[i];
		background_colors_html += '<option style="background-color:'+color.color+';" value="'+color.color+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>';
	}
	background_colors_html += '<option style="background-color:#fff" class="custom" value="#ffffff">custom</option>';
	$j('#calendar_events_color').html( background_colors_html );
	$j('#calendar_events_color').change( jQuery.planscalendar.update_calendar_background_select );
	$j('#calendar_events_color').change( jQuery.planscalendar.update_merged_calendars_display_style);

	// custom color selected?
	var s = $j('#calendar_events_color option[value=' + calendar.calendar_events_color + ']').attr('selected','selected');

	if ( s.length == 0 && calendar.calendar_events_color ) {
		$j('#calendar_events_color option.custom').attr('selected','selected');
		$j('#calendar_events_color option.custom').val(calendar.calendar_events_color);
		$j('#calendar_events_color .custom').css('background-color', calendar.calendar_events_color);
		$j('#calendar_events_color').css('background-color', calendar.calendar_events_color);

	}

	// events that trigger a change in preview
	$j('.merged_calendars_display_style_click_trigger').bind('click', jQuery.planscalendar.update_merged_calendars_display_style);
	$j('.merged_calendars_display_style_change_trigger').bind('change', jQuery.planscalendar.update_merged_calendars_display_style);


	// background events color
	$j('#background_events_color').html( calendar.background_events_color );
	var f = function(hsb, hex, rgb) {
		$j('#background_events_color').val('#'+hex);
		jQuery.planscalendar.update_merged_calendars_display_style();
	}
	$j('#background_events_color_select_icon').ColorPicker({onSubmit:f});



	// populate translucency dropdown
	var background_translucency_html = '';
	for( var i=70;i>0;i-=10) {
		background_translucency_html += '<option value="'+i+'">'+i+' %</option>';
	}
	$j('#background_events_fade_factor').html( background_translucency_html );


	$j('#background_events_color').val( calendar.background_events_color );
	$j('#background_events_fade_factor option[value=' + calendar.background_events_fade_factor + ']').attr('selected','selected');
	$j('input[name=background_events_display_style][value='+calendar.background_events_display_style+']').attr('checked','checked');


	// list users
	var results = '';
	for (var i=0;i<calendar.users.length;i++) {
		var user = calendar.users[i];
    	results += user.name+' <a id="'+user.id+'_edit_user_link" href="javascript:void(0)">('+get_lang('edit')+')</a><br/>';
	}
	$j('#list_users').html(results);

	for (var i=0;i<calendar.users.length;i++) {
		var user = calendar.users[i];
		$j('#'+user.id+'_edit_user_link').click(partial(jQuery.planscalendar.edit_user, this, user));
	}
 
	// add user link
	$j('#add_user_link').click(jQuery.planscalendar.add_user);


	jQuery.planscalendar.update_calendar_background_select(calendar.calendar_events_color);
	jQuery.planscalendar.update_merged_calendars_display_style();

	// remote calendars

	// list current remote calendars
	jQuery.planscalendar.list_remote_calendars();



}

jQuery.planscalendar.update_merged_calendars_display_style = function() {
	info('lpd0');

	// same-calendar events
	if ( $j('#calendar_events_color').val() == '' ) {
		$j('#preview_e1').css('background-color', '#ffffcc');
		$j('#preview_e2').css('background-color', '#ccffcc');
	} else {
		$j('#preview_e1').css('background-color',  $j('#calendar_events_color').val());
		$j('#preview_e2').css('background-color',  $j('#calendar_events_color').val());
	}

	// background calendar events

	if ( $j('#background_events_display_style1:checked').length > 0 ) {
		$j('#bg_preview_e1').css({'background-color': '#ffffcc','opacity':'1'});
		$j('#bg_preview_e2').css({'background-color': '#ccffff','opacity':'1'});

	} else if ( $j('#background_events_display_style2:checked').length > 0 ) {
		var c = $j('#background_events_color').val();
		if ( c == '' ) {
			$j('#background_events_color').val('#ffffff');
			c = '#ffffff';
		}
		$j('#bg_preview_e1').css('background-color', c);
		$j('#bg_preview_e2').css('background-color', c);
	} else if ( $j('#background_events_display_style3:checked').length > 0 ) {
		var o = 1 - ($j('#background_events_fade_factor').val() / 100);
		info(o);
		$j('#bg_preview_e1').css({'background-color': '#ffffcc','opacity':o});
		$j('#bg_preview_e2').css({'background-color': '#ccffff','opacity':o});
	}

	// hook up "add new remote calendars" button
	$j('#get_remote_calendars_button').click(jQuery.planscalendar.get_remote_calendars);


}

jQuery.planscalendar.list_remote_calendars = function() {

	var remote_calendars = jQuery.planscalendar.current_calendar_being_edited.remote_background_calendars;
	info( 'remote_calendars');
	info(remote_calendars);

	if ( !remote_calendars ) return;

	var contents = '';
	for( var i=0;i<remote_calendars.length;i++ ) {

		var remote_calendar = remote_calendars[i];

		contents += tmpl('remote_calendar_tmpl', remote_calendar);

	}
	info(contents);

	$j('#remote_calendars_list').html(contents);
	jQuery.planscalendar.insert_lang_string( $j('#remote_calendars_list'), ['get_remote_calendars3'] );

}

jQuery.planscalendar.get_remote_calendars = function() {
	$j('#get_remote_calendars_dialog').show().dialog({title:plans_lang['get_remote_calendars'],height:600,width:700});

	$j('#check_remote_calendars_button').val(plans_lang['check_remote_calendars_button']);
	$j('#check_remote_calendars_button').click(jQuery.planscalendar.check_remote_calendars);
	$j('#remote_calendars_url').focus();
	$j('#remote_calendars_url').keypress(function(evt){if(evt.keyCode == 13){jQuery.planscalendar.check_remote_calendars()}});

}


jQuery.planscalendar.check_remote_calendars = function() {
	info('checking remote calendars');

	var data = {
		'api_command':'detect_remote_calendars',
		'remote_calendar_url': $j('#remote_calendars_url').val()
		};

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			jQuery.planscalendar.current_remote_calendars = jsondata;  
			jQuery.planscalendar.display_available_remote_calendars(jsondata.public_calendars);

			info('success!');
		}
	}

	$j('#check_remote_calendars_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Checking...</span>'
	});

	$j.ajax({
		'url':plans_url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});
}


jQuery.planscalendar.display_available_remote_calendars = function(available_remote_calendars) {
	if ( ! available_remote_calendars || available_remote_calendars.length == 0 || available_remote_calendars[0] == null ) {
		$j('#available_remote_calendars').html('<li>' + plans_lang['detect_remote_calendars5'] + '</li>')
		return;
	}
	
	var contents = '';
	for( var i=0;i<available_remote_calendars.length;i++ ) {

		var available_remote_calendar = available_remote_calendars[i];

		available_remote_calendar.display_class = ( i % 2 == 0 ) ? 'list_even' : 'list_odd';

		contents += tmpl('available_remote_calendar_tmpl', available_remote_calendar);

	}
	
	$j('#available_remote_calendars').html(contents);

	for( var i=0;i<available_remote_calendars.length;i++ ) {
		var available_remote_calendar = available_remote_calendars[i];
		if ( available_remote_calendar.requires_password == 'yes' ) {
			$j('#remote_calendar_password_required_' + available_remote_calendar.id).show();
		}
	}

	if (	available_remote_calendars.length > 0 ) {
		$j('#merge_selected_calendars_link').show().click(jQuery.planscalendar.merge_selected_remote_calendars);
	}


	jQuery.planscalendar.insert_lang_string( $j('#available_remote_calendars'), ['detect_remote_calendars2', 'detect_remote_calendars3'] );


}

jQuery.planscalendar.merge_selected_remote_calendars = function() {

	var remote_calendars = jQuery.planscalendar.current_remote_calendars.public_calendars;
	
	var new_remote_calendars_xml = '';

	var n_merged = 0;
	for( var i=0;i<remote_calendars.length;i++ ) {

		var available_remote_calendar = remote_calendars[i];

		if ( $j('#merge_remote_calendar_checkbox_' + available_remote_calendar.id+':checked').length > 0 ) {

			jQuery.extend(available_remote_calendar, {
				'plans_version':jQuery.planscalendar.current_remote_calendars.remote_calendar_version,
				'url':jQuery.planscalendar.current_remote_calendars.url,
				'password':$j('#remote_calendar_password_'+available_remote_calendar.id).val()
			});

			var merge_xml = tmpl('remote_calendar_xml_tmpl', available_remote_calendar);

			info( merge_xml );

			n_merged++;

			new_remote_calendars_xml += merge_xml;
		}
		
	}

	new_remote_calendars_xml += '<remote_calendars>' + merge_xml + '</remote_calendars>';

	$j('#new_remote_calendars_xml').val(new_remote_calendars_xml);
	
	$j('#get_remote_calendars_dialog').dialog('close');

	if ( n_merged > 0 ) {

		var status_text = '';

		if ( n_merged == 1 ) {
			status_text = n_merged + ' ' + plans_lang['get_remote_calendar2_singular'] + ' ' + jQuery.planscalendar.current_calendar_being_edited.title;
		} else {
			status_text = n_merged + ' ' + plans_lang['get_remote_calendar2_plural'] + ' ' + jQuery.planscalendar.current_calendar_being_edited.title;
		}

		$j('#remote_background_calendars_status').html( status_text );
	}

}

jQuery.planscalendar.check_remote_calendars_response_callback = function(rsp) {
	info('remote calendars response:');
	info(rsp);

}





jQuery.planscalendar.add_user = function() {

	$j('#add_edit_user_dialog').show().dialog({title:plans_lang['add_user'],height:400,width:500});

	$j('#user_id').val('');
	$j('#user_name').val('');
	$j('#add_edit_user_submit_button').val(get_lang('add_user'));
	$j('#add_edit_user_submit_button').click(jQuery.planscalendar.add_edit_user_submit);

	$j('#delete_user_button').hide();
}

jQuery.planscalendar.edit_user = function(user) {

	$j('#add_edit_user_dialog').show().dialog({title:plans_lang['add_user'],height:600,width:500});

	$j('#user_id').val(user.id);
	$j('#user_name').val(user.name);
	$j('#add_edit_user_submit_button').val(get_lang('update_user'));
	$j('#add_edit_user_submit_button').click(jQuery.planscalendar.add_edit_user_submit);
	$j('#delete_user_button').show().val(plans_lang['delete_user']).click(partial( jQuery.planscalendar.add_edit_user_submit, this, true ) );

}

jQuery.planscalendar.add_edit_user_submit = function( delete_user ) {

	var data = {
		'api_command':'add_edit_user',
		'delete': ( delete_user ) ? '1' : '',
		'cal_id':jQuery.planscalendar.current_calendar_being_edited.id,
		'user_id': $j('#user_id').val() || '',
		'name': $j('#user_name').val(),
		'password': $j('#user_password').val(),
		'repeat_password': $j('#user_repeat_password').val(),
		'new_password': $j('#user_new_password').val(),
		'cal_password':$j('#add_edit_user_cal_password').val()
		};


	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			info('success!');

			jQuery.planscalendar.update_calendars(jsondata.calendars);

			jQuery.planscalendar.populate_add_edit_calendar_dialog( jQuery.planscalendar.current_calendar_being_edited);

			$j('#add_edit_user_dialog').dialog('close');
		}
	}

	$j('#add_edit_user_submit_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Please Wait...</span>'
	});

	$j.ajax({
		'url':plans_url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});



}

jQuery.planscalendar.update_calendar_background_select = function(initial_color) {

	var selected = $j('#calendar_events_color :selected');
	info(selected.html());
	var color = selected.val();
	$j('#calendar_events_color').css('background-color', color);

	if ( selected.hasClass( 'custom' ) ) {
		$j('#calendar_events_color_select_icon').fadeIn();

		var f = function(hsb, hex, rgb) {
			$j('#calendar_events_color').css('background-color', '#'+hex);
			info(selected);
			$j('#calendar_events_color .custom').css('background-color', '#'+hex);
			$j('#calendar_events_color .custom')[0].value = '#'+hex;
			$j('.colorpicker').hide();
		}

		var parms = {onSubmit:f};

		info('initial_color');
		info(initial_color);

		if (initial_color) {
			jQuery.extend(parms,  {
				onBeforeShow: function () {
					jQuery(this).ColorPickerSetColor(initial_color);
				}
			});
		}

		$j('#calendar_events_color_select_icon').ColorPicker(parms);
		$j('.colorpicker').css({'zIndex':10000});
	} else {
		$j('#calendar_events_color_select_icon').fadeOut();
	}

}

jQuery.planscalendar.add_edit_calendar_submit = function( ) {

	var url = plans_url;

	var data = {
		'api_command':'add_update_calendar',
		'cal_title':$j('#add_edit_calendar_cal_title').val(),
		'cal_link':$j('#add_edit_calendar_cal_link').val(),
		'cal_details':$j('#add_edit_calendar_details').val(),
		'date_format':$j('#date_format').val(),
		'default_number_of_months':$j('#default_number_of_months').val(),
		'max_number_of_months':$j('#max_number_of_months').val(),
		'gmtime_diff':$j('#gmtime_diff').val(),
		'event_change_email':$j('#event_change_email').val(),
		'week_start_day':$j('#week_start_day').val(),
		'calendar_events_color':$j('#calendar_events_color').val(),
		'background_events_display_style':$j('input[name=background_events_display_style]:checked').val(),
		'background_events_fade_factor':$j('#background_events_fade_factor').val(),
		'background_events_color':$j('#background_events_color').val(),
		'new_remote_calendars_xml':$j('#new_remote_calendars_xml').val()
	};


	if ( jQuery.planscalendar.current_calendar_being_edited == null ) {
		jQuery.extend(data, {
			'add_edit_cal_action':'add',
			'cal_password':$j('#add_calendar_cal_password').val(),
			'new_cal_password':$j('#add_calendar_new_cal_password').val(),
			'repeat_new_cal_password':$j('#add_calendar_repeat_new_cal_password').val()

		});
	} else {
		jQuery.extend(data, {
			'add_edit_cal_action':'edit',
			'cal_id':jQuery.planscalendar.current_calendar_being_edited.id,
			'cal_password':$j('#edit_calendar_cal_password').val(),
			'new_cal_password':$j('#edit_calendar_new_cal_password').val(),
			'repeat_new_cal_password':$j('#edit_calendar_repeat_new_cal_password').val()

		});

		if ( jQuery.planscalendar.current_calendar_being_edited.remote_background_calendars && 
			 jQuery.planscalendar.current_calendar_being_edited.remote_background_calendars.length > 0 ) {
			for ( var i=0;i<jQuery.planscalendar.current_calendar_being_edited.remote_background_calendars.length;i++) {
				var rbc = jQuery.planscalendar.current_calendar_being_edited.remote_background_calendars[i];

				if ( $j('#delete_remote_calendar_'+rbc.remote_id+':checked').length > 0 ) {
					data['delete_remote_calendar_'+rbc.remote_id] = 'y';
				}
			}
		} 
		

	}

	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			info('success!');
			
			return;

		//	$j('#add_edit_event_dialog').dialog('close');

			//$j('table.calendar').replaceAll($j(jsondata.calendar_html));
			//$j('table.calendar').replaceAll(jsondata.calendar_html);
			var parent_el = $j('table.calendar').parent();
			$j('table.calendar').remove();
			parent_el.append(jsondata.calendar_html);
			jQuery.planscalendar.hookup_contextmenu_events();
			$j.merge(events, jsondata.new_events);


		}
	}

	$j('#add_cal_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Please Wait...</span>'
	});

	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});

}

jQuery.planscalendar.delete_calendar_submit = function( ) {

	var url = plans_url;

	var data = {
		'api_command':'add_update_calendar',
		'cal_id':jQuery.planscalendar.current_calendar_being_edited.id,
		'add_edit_cal_action':'delete',
		'cal_password':$j('#edit_calendar_cal_password').val(),
		'new_calendar_controls':1
	}

	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			
			menu_tabs = $j('#menu_tabs > ul').tabs('select',0);
			jQuery.planscalendar.update_calendars(jsondata.calendars);
			$j('#server_supplied_calendar_controls').html(jsondata.calendar_controls);

		}
	}

	$j('#del_cal_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Please Wait...</span>'
	});

	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});

}



jQuery.planscalendar.reset_tabs = function( ) {
	menu_tabs = $j('#menu_tabs > ul').tabs('select',0);
}

jQuery.planscalendar.show_edit_event_dialog = function() {

	$j('#add_edit_event_submit_button').val(plans_lang['update_event']);
}

jQuery.planscalendar.show_add_edit_event_dialog = function() {

	var menu_tabs_el = $j('#menu_tabs ul');
	var c = menu_tabs_el.offset();
	c.height = menu_tabs_el.height();
	c.width = menu_tabs_el.width();

	var w = $j('#menu_tabs').width();
	var c2 = $j('#menu_tabs').offset();

	$j('#add_edit_event_tabs').tabs();
	$j('#add_edit_event_tabs').tabs('select',0);

	$j('.ui-dialog.add_edit').css({'height':'auto'});
	$j('#add_edit_event_dialog').css({'height':'auto'});
	$j('#recurrence_already_defined').hide();
	$j('#recurrence_not_allowed').hide();

	$j('#add_edit_event_start_date').datepicker({ 
		showOn: 'button', 
		buttonImage: theme_url + "/images/calendar.gif", 
		buttonImageOnly: true 
	});

	$j('#add_edit_event_recur_end_date').datepicker({ 
		showOn: 'button', 
		buttonImage: theme_url + "/images/calendar.gif", 
		buttonImageOnly: true 
	});

	$j('#ui-datepicker-div').css({'zIndex':10000});

	$j('#add_edit_event_all_day_event').change( update_all_day_event_checkbox );

	// populate icons dropdown
	var f = function(d, selfref){
		if (typeof(d[1]) == typeof('a')) {
			return '<option value="'+d[0]+'">'+d[1]+'</option>';
		}
		
		if (typeof(d[1]) == typeof(['a'])) {
			var results = '<optgroup label="'+d[0]+'">';
			for( var i=0;i<d[1].length;i++) {
				results += f(d[1][i], f);
			}
			results += '</optgroup>';
			return results;
		}
		return '';
	};

	icons_html = '';
	for( var i=0;i<icons.length;i++) {
		icons_html += f(icons[i], f);
	}

	$j('#add_edit_event_icon').html( icons_html );

	// hook up icon preview

	$j('#add_edit_event_icon').change(jQuery.planscalendar.update_icon_preview);
	jQuery.planscalendar.update_icon_preview();

	// populate background colors dropdown
	var background_colors_html = '';
	for( var i=0;i<event_background_colors.length;i++) {
		var color = event_background_colors[i];
		background_colors_html += '<option style="background-color:'+color.color+';" value="'+color.color+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>';
	}
	background_colors_html += '<option style="background-color:#fff" class="custom" value="#ffffff">custom</option>';
	$j('#add_edit_event_background_color').html( background_colors_html );
	$j('#add_edit_event_background_color').change( jQuery.planscalendar.update_event_background_select );

	// populate month select for recurring event
	$j('#add_edit_event_custom_months').empty();
	for (var i=0;i<plans_lang['months'].length;i++) {
		$j('#add_edit_event_custom_months').append($j('<option value="'+i+'">'+plans_lang['months'][i]+'</option>'));
	}

	// populate calendar select 
	$j('#add_edit_event_cal_id').empty();
	for (var i=0;i<jQuery.planscalendar.calendars.length;i++) {
		var calendar = jQuery.planscalendar.calendars[i];
		$j('#add_edit_event_cal_id').append('<option value="' + calendar.id  + '">' + calendar.title + '</option>');
	}

	// hookup recurring event actions
	$j('.recurring_event_click_trigger').bind('click', jQuery.planscalendar.update_recurring_events);
	$j('.recurring_event_change_trigger').bind('click', jQuery.planscalendar.update_recurring_events);

	
	$j('#add_edit_event_submit_button').bind('click', jQuery.planscalendar.add_edit_event_submit);

	jQuery.planscalendar.update_recurring_events();

	// hookup preview events
	$j('#preview_event').bind('click', jQuery.planscalendar.preview_event);
	$j('#preview_dates').bind('click', jQuery.planscalendar.preview_dates);

	// if logged in, don't show password prompt
	if (jQuery.planscalendar.logged_in) {
		$j('#add_edit_event_cal_password_field').hide();
	}else {
		$j('#add_edit_event_cal_password_field').show();
	}
}

function update_all_day_event_checkbox(e){
	if ($j('#add_edit_event_all_day_event')[0].checked) {
		$j('#event_time_inputs').slideUp('fast');
	} else {
		$j('#event_time_inputs').slideDown('fast');
	}
}

jQuery.planscalendar.preview_event = function() {
	var event = {
	'cal_ids':[$j('#add_edit_event_cal_id').val()],
	'title':$j('#add_edit_event_title').val(),
	'details':$j('#add_edit_event_details').val(),
	'bgcolor':$j('#add_edit_event_background_color').val(),
	'icon':$j('#add_edit_event_icon').val(),
	'unit_number':'',
	'nice_date':'(date disabled for preview)',
	'nice_time':'(time disabled for preview)',
	'id':''
	}

	jQuery.planscalendar.display_local_event(event);
}

jQuery.planscalendar.preview_dates = function() {

	var url = plans_url;

	var data = {
		'api_command':'preview_date',
		'cal_id':$j('#add_edit_event_cal_id').val(),
		'evt_title':$j('#add_edit_event_title').val(),
		'evt_details':$j('#add_edit_event_details').val(),
		'evt_start_date':$j('#add_edit_event_start_date').val(),
		'evt_days':$j('#add_edit_event_days').val(),
		'evt_all_day_event':$j('#add_edit_event_all_day_event').val(),
		'evt_start_time':$j('#add_edit_event_start_time').val(),
		'evt_end_time':$j('#add_edit_event_end_time').val(),
		'evt_icon':$j('#add_edit_event_icon').val(),
		'evt_bgcolor':$j('#add_edit_event_background_color').val(),
		'cal_password':$j('#add_edit_event_cal_password').val(),

		'recurring_event':( $j('#add_edit_event_recurring_event:checked').length > 0 ) ? '1' : '',
		'every_x_days':$j('#add_edit_event_every_x_days').val(),
		'every_x_weeks':$j('#add_edit_event_every_x_weeks').val(),
		'weekday_of_month_type':$j('#add_edit_event_weekday_of_month_type option:selected').val(),
		'year_fit_type':$j('input[name=add_edit_event_year_fit_type]:checked').val(),
		'custom_months':$j('#add_edit_event_custom_months').val(),
		'recurrence_type':$j('input[name=add_edit_event_recurrence_type]:checked').val(),
		'recur_end_date':$j('#add_edit_event_recur_end_date').val()

	};
	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			
			var f = function(event, ui) {
				$j('#preview_dates_dialog').dialog('destroy');
				return false;
			}

			var text = '';
			for (var i=0;i<jsondata.valid_dates.length;i++) {
				text += tmpl('preview_date_tmpl', {'date':jsondata.valid_dates[i]});
			}
			$j('#preview_dates_list').html(text);
			if ( $j('#add_edit_event_recurring_event:checked').length > 0 ) {
				$j('.lang_date_preview_recurring_event_falls_on').show();
				$j('.lang_date_preview_this_event_falls_on').hide();
			} else  {
				$j('.lang_date_preview_recurring_event_falls_on').hide();
				$j('.lang_date_preview_this_event_falls_on').show();
			}

<span class=""></span>


			$j('#preview_dates_dialog').dialog({'width':500,'position':'center', 'beforeclose': f });
		}
	}

	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});




}


jQuery.planscalendar.display_help = function(topic, title) {
	var key = 'help_'+topic;
	info(key);
	var text = plans_lang[key];
	info(text);

	var f = function(event, ui) {
		$j('#help_dialog').dialog('destroy');
		return false;
	}


	$j('#help_dialog').html(text).dialog({'width':500,'position':'center', 'beforeclose': f });

}


jQuery.planscalendar.update_icon_preview = function() {
	var selected = $j('#add_edit_event_icon :selected');
	var icon_name = selected.val();
	$j('#icon_preview_img')[0].src = theme_url + '/icons/' + icon_name + '_32x32.gif';
}

jQuery.planscalendar.update_event_background_select = function() {

	var selected = $j('#add_edit_event_background_color :selected');
	info(selected.html());
	var color = selected.val();
	$j('#add_edit_event_background_color').css('background-color', color);

	if ( selected.hasClass( 'custom' ) ) {
		$j('#event_color_select_icon').fadeIn();

		var f = function(hsb, hex, rgb) {
			$j('#add_edit_event_background_color').css('background-color', '#'+hex);
			info(selected);
			$j('#add_edit_event_background_color .custom').css('background-color', '#'+hex);
			$j('#add_edit_event_background_color .custom')[0].value = '#'+hex;
			$j('.colorpicker').hide();
		}

		$j('#event_color_select_icon').ColorPicker({onSubmit:f});
		$j('.colorpicker').css({'zIndex':10000});
	} else {
		$j('#event_color_select_icon').fadeOut();
	}

}

jQuery.planscalendar.update_recurring_events = function(evt) {
	if ( $j('#add_edit_event_recurring_event:checked').length > 0 ) {
		$j('#add_edit_event_recurrence .form_field input').attr('disabled',false);
		$j('#add_edit_event_recurrence .form_field select').attr('disabled',false);


		if ( $j('#add_edit_event_recurrence_type_same_weekday:checked').length == 0 ) {
			$j('#add_edit_event_weekday_of_month_type').attr('disabled',true);
		} else {
			$j('#add_edit_event_weekday_of_month_type').focus();
		}

		if ( $j('#add_edit_event_recurrence_type_every_x_days:checked').length == 0 ) {
			$j('#add_edit_event_every_x_days').attr('disabled',true);
		} else {
			$j('#add_edit_event_every_x_days').focus();
		}

		if ( $j('#add_edit_event_recurrence_type_every_x_weeks:checked').length == 0 ) {
			$j('#add_edit_event_every_x_weeks').attr('disabled',true);
		} else {
			$j('#add_edit_event_every_x_weeks').focus();
		}

		if ( $j('#add_edit_event_year_fit_type_custom_months:checked').length == 0 ) {
			$j('#add_edit_event_custom_months').attr('disabled',true);
		} else {
			$j('#add_edit_event_custom_months').focus();
		}

	} else {
		// recurring events disabled
		$j('#add_edit_event_recurrence .form_field input').attr('disabled',true);
		$j('#add_edit_event_recurrence .form_field select').attr('disabled',true);
		$j('#add_edit_event_recurrence .form_field input[type=checkbox]').attr('disabled',false);
	}
}


jQuery.planscalendar.populate_add_edit_event_dialog = function(event) {
	info(event);
	if (event.id != null) {
		if (event.series_id == null ) {
			$j('#recurrence_not_allowed').show();
		} else {
			$j('#recurrence_already_defined').show();
		}
		$j('#define_recurrence').hide();
	} else {
		$j('#define_recurrence').show();
	}

	$j('#add_edit_event_id').val(event.id || '');

	$j('#add_edit_event_title').val(event.title || '');
	$j('#add_edit_event_details').val(event.details || '');

	$j('#add_edit_event_all_day_event')[0].checked = ( event.all_day_event == '1' );
	update_all_day_event_checkbox();

	var start_date = (event.start) ? new Date(event.start * 1000) : new Date(); 
	var end_date = (event.end) ? new Date(event.end * 1000) : new Date(); 
	$j('#add_edit_event_start_date').val(formatDate(start_date, jQuery.planscalendar.date_format.replace(/mm/,'MM')) || '');

	$j('#add_edit_event_start_time').val(formatDate(start_date,"sh:mm ampm"));
	if (event.no_end_time == '1') {
		$j('#add_edit_event_end_time').val('');
	} else {
		$j('#add_edit_event_end_time').val(formatDate(end_date,"sh:mm ampm"));
	}

	$j('#add_edit_event_icon option[value=' + event.icon + ']').attr('selected','selected');
	jQuery.planscalendar.update_icon_preview();

	$j('#add_edit_event_background_color option[value=' + event.bgcolor + ']').attr('selected','selected');
	jQuery.planscalendar.update_event_background_select();

}


jQuery.planscalendar.add_edit_event_submit = function( ) {

	var url = plans_url;
	var event_id = $j('#add_edit_event_id').val();

	var data = {
		'api_command':'add_update_event',
		'evt_id': event_id,
		'add_edit_event': (event_id != '') ? 'edit' : 'add',
		'cal_id':$j('#add_edit_event_cal_id').val(),
		'evt_title':$j('#add_edit_event_title').val(),
		'evt_details':$j('#add_edit_event_details').val(),
		'evt_start_date':$j('#add_edit_event_start_date').val(),
		'evt_days':$j('#add_edit_event_days').val(),
		'evt_all_day_event':$j('#add_edit_event_all_day_event').val(),
		'evt_start_time':$j('#add_edit_event_start_time').val(),
		'evt_end_time':$j('#add_edit_event_end_time').val(),
		'evt_icon':$j('#add_edit_event_icon').val(),
		'evt_bgcolor':$j('#add_edit_event_background_color').val(),
		'cal_password':$j('#add_edit_event_cal_password').val(),

		'recurring_event':( $j('#add_edit_event_recurring_event:checked').length > 0 ) ? '1' : '',
		'every_x_days':$j('#add_edit_event_every_x_days').val(),
		'every_x_weeks':$j('#add_edit_event_every_x_weeks').val(),
		'weekday_of_month_type':$j('#add_edit_event_weekday_of_month_type option:selected').val(),
		'year_fit_type':$j('input[name=add_edit_event_year_fit_type]:checked').val(),
		'custom_months':$j('#add_edit_event_custom_months').val(),
		'recurrence_type':$j('input[name=add_edit_event_recurrence_type]:checked').val(),
		'recur_end_date':$j('#add_edit_event_recur_end_date').val()

	};
	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			var parent_el = $j('table.calendar').parent();
			$j('table.calendar').remove();
			parent_el.append(jsondata.calendar_html);
			jQuery.planscalendar.hookup_contextmenu_events();
			$j.merge(jQuery.planscalendar.events, jsondata.new_events);

			$j('#menu_tabs').tabs('select',0);
		}
	}

	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});

}



jQuery.planscalendar.rawResponseCallback = function(data, type) {
	info(data);
	info(type);
	return data;
}


jQuery.planscalendar.update_messages = function(messages) {
	if (typeof(messages) == typeof([]) && messages.length == 0 ) {
		return;
	}

	var formatted_messages = jQuery.planscalendar.format_messages(messages);
	var text = formatted_messages.join('<br/>');

	$j.jGrowl(text, jgrowl_opts);

}

jQuery.planscalendar.format_messages = function(messages) {
	for( var i=0;i<messages.length;i++) {
		if ( !messages[i] ) continue;
		messages[i] = messages[i].replace(/\[status\]/, "");
		messages[i] = messages[i].replace(/\[warning\]/, '<span class="warning">Warning:</span> ');
		messages[i] = messages[i].replace(/\[error\](.+)/, function($1, $2){return '<span class="error_message">' + $2 + '</span> ';});
	}
	return messages;
}


jQuery.planscalendar.update_login = function() {
	var login_el = $j('#login_logout');

	if ( login_el.length ==0 ) return;

	if (!plans_options['sessions']) {
		login_el.hide();
    	return;
  	}

	if (jQuery.planscalendar.logged_in) {
		$j('#logout_link').show();
		$j('#login_link').hide();
	}
	else {
		$j('#logout_link').hide();
		$j('#login_link').show();
		$j('#login_link').click(jQuery.planscalendar.show_login_dialog);
	}

}

jQuery.planscalendar.show_login_dialog = function() {


	var f = function(event, ui) {
		$j('#login_dialog').dialog('destroy');
		return false;
	}
	$j('#login_submit_button').val(plans_lang['login']);

	$j('#login_dialog').dialog({'title':plans_lang['login'], 'width':500,'position':'center', 'beforeclose': f });
	

	$j('#login_submit_button').click(jQuery.planscalendar.login_submit);

}

jQuery.planscalendar.login_submit = function(args) {
  
  var url = plans_url;
 
/* 
  if (logout)
    url += "&logout=1";
  else if (document.getElementById("login_password")) {
    var pwd = document.getElementById("login_password").value;
    url += "&cal_password="+pwd;
  }
*/

	var pwd = '';
	if ( $j('#login_password').length > 0 ) {
		pwd = $j('#login_password').val();
	}


	var data = {
		'api_command':'js_login',
		'cal_id':jQuery.planscalendar.current_calendar_id,
		'cal_password':pwd
	};
	/*
	if (args.logout) {
			$j.merge(data, {'logout':'1'});
	}
	*/	
	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			jQuery.planscalendar.logged_in = true;
			$j.cookie('plans_sid', jsondata.session_id, { path: jsondata.cookie_path, expires: 1000 });
			jQuery.planscalendar.update_login();
			$j('#login_dialog').dialog('destroy');
		}
	}

	$j('#login_submit_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Logging in...</span>'
	});


	$j.ajax({
		'url':url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});

	return;
  
  try {
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange=function() {
      if (xmlhttp.readyState==4) {
        
        eval(xmlhttp.responseText);
        
        jQuery.planscalendar.update_messages(messages);
        jQuery.planscalendar.update_login();
      }
    }
    xmlhttp.send(null)
  } catch (e) {} // do nothing
}

function login() {
  jQuery.planscalendar.update_messages("logging in...");
  login_logout(false);
  
}

function logout() {
  jQuery.planscalendar.update_messages("logging out...");
  login_logout(true);
}


jQuery.planscalendar.add_ical = function( ) {

	$j('#add_ical_dialog').show().dialog({title:plans_lang['add_new_ical_calendar'],height:180,width:750});
	$j('#add_ical_submit_button').val(get_lang('add_ical'));
	$j('#add_ical_submit_button').click(jQuery.planscalendar.add_ical_submit);

}

jQuery.planscalendar.add_ical_submit = function( ) {

	var data = {
		'api_command':'add_ical',
		'ical_url': $j('#ical_url').val() || '',
		'cal_password':$j('#add_ical_cal_password').val()
		};


	info(data);

	var successCallback = function(jsondata, statusText) {
		info(statusText);
		info(jsondata);
		jQuery.planscalendar.update_messages(jsondata.messages);
		if (jsondata.success == true) {
			info('success!');

			jQuery.planscalendar.update_calendars(jsondata.calendars);

			jQuery.planscalendar.populate_add_edit_calendar_dialog( jQuery.planscalendar.current_calendar_being_edited);

			$j('#add_edit_user_dialog').dialog('close');
		}
	}

	$j('#add_ical_submit_button').throbber({
		image: theme_url + "/images/throbber.gif",
		wrap: '<span>Please Wait...</span>'
	});

	$j.ajax({
		'url':plans_url,
		'type':'POST',
		'data':data,
		'dataType':'json',
		'success':successCallback
	});



}



function list_users() {
  if (!users || users.length == 0) return;
  
  var results = "";
  //for (i=0;i<users.length;i++)
  for (var i in users)
  {
    results += users[i].name+' <a id="'+users[i].id+'_edit_user_link" href="javascript:add_edit_user('+users[i].id+')">('+get_lang('edit')+')</a><br/>';
  }
  
  if (document.getElementById('select_users'))
    document.getElementById('select_users').innerHTML = results;
}



function toggle_visible(elname) 
{

  if (document.getElementById(elname) == null) return;
  el = document.getElementById(elname);
      

  if (el.style.display == "none") 
    el.style.display = ""
  else
    el.style.display = "none"
}

function toggle_login(elname) 
{
  toggle_visible(elname);
  
  if ((document.getElementById('login_switch').innerHTML == '[x]')) 
  {
    document.getElementById('login_switch').innerHTML = 'Login';
    document.getElementById('login_switch').style.top = '0';
    document.getElementById('login_switch').style.left = '0';
  }
  else {
    document.getElementById('login_switch').innerHTML = '[x]';
    document.getElementById('login_switch').style.top = '-10px';
    document.getElementById('login_switch').style.left = '5px';
  }
  
  
  
}




function update_remote_calendar_requests()
{
  if (!document.update_cal_form || !document.update_cal_form.allow_remote_calendar_requests)
    return;

  if (document.update_cal_form.allow_remote_calendar_requests.checked)
  {
    document.update_cal_form.remote_calendar_requests_require_password.disabled = false;
    if (document.update_cal_form.remote_calendar_requests_require_password.checked)
      document.update_cal_form.remote_calendar_requests_password.disabled = false;
  } 
}

function delete_event(t) {

	info('delete_event');

  var text = ''
  if (logged_in || plans_options['disable_passwords'] == 1) {
    if (active_series_id) {
      text += '<div class="leftcol"><span class="required_field">'+plans_lang['recurring_event_delete_all1']+'</span></div>';
      text += '<div class="rightcol"><a id="delete_event_series_submit" href="javascript:{}">'+get_lang('recurring_event_delete_all2')+'</a>';
      text += '<br/><a id="delete_event_submit" href="javascript:{}">'+get_lang('recurring_event_delete_all3')+'</a></div>';
    } else {
      text += '<div class="leftcol"><span class="required_field">'+plans_lang['event_delete1']+'</span></div>';
      text += '<div class="rightcol"><a id="delete_event_submit" href="javascript:{}">'+get_lang('event_delete2')+'</a></div>';
    }
  } else {
    text += '<div class="leftcol"><span class="required_field">'+plans_lang['password']+':</span></div>';
    text += '<div class="rightcol"><input type="password" id="delete_event_cal_password" value="'+''+'"/></div>';
    if (active_series_id) {
      text += '<div class="leftcol"><span class="required_field">'+plans_lang['recurring_event_delete_all1']+'</span></div>';
      text += '<div class="rightcol"><a id="delete_event_series_submit" href="javascript:{}">'+get_lang('recurring_event_delete_all2')+'</a>';
      text += '<br/><a id="delete_event_submit" href="javascript:{}">'+get_lang('recurring_event_delete_all3')+'</a></div>';
    } else {
      text += '<div class="leftcol"><span class="required_field">'+plans_lang['event_delete1']+':</span></div>';
      text += '<a id="delete_event_submit" href="javascript:{}">'+get_lang('event_delete2')+'</a></div>';
    }
  }
  $j('#delete_event_dialog').attr('title',get_lang('delete_event')).html(text).show().dialog({height:'auto',width:'auto'});
  $j('#delete_event_cal_password').focus();
  $j('a#delete_event_submit').bind('click', delete_event_submit);
  $j('a#delete_event_series_submit').bind('click', partial(delete_event_submit, this, {all_in_series:true}));

}

function delete_event_submit(options, e) {
	if (!options) options = {};
	options.all_in_series = options.all_in_series || false;

  var cal_password = ($j('#delete_event_cal_password').length > 0) ? $j('#delete_event_cal_password')[0].value : '';
  
	var url = plans_url
	var parms = {api_command : 'delete_event',
				output_format : 'json',
				evt_id : active_event_id
				};
  
	if (cal_password != '')
		parms.cal_password = cal_password;
	
    
	if (options.all_in_series && active_series_id != '') {
		parms.all_in_series = 1;
		parms.series_id = active_series_id;
	}

	var successCallback = function(jsondata, statusText) {
		info('response data');
        jQuery.planscalendar.update_messages(jsondata.messages);
  		$j('#delete_event_dialog').dialog('close');
	
		if (jsondata.success) {
			var parent_el = $j('table.calendar').parent();
			$j('table.calendar').remove();
			parent_el.append(jsondata.calendar_html);
			jQuery.planscalendar.hookup_contextmenu_events();
			$j.merge(events, jsondata.new_events);
		}
		
	}
	$j('#delete_event_submit').html(get_lang('deleting') + '...');
	$j('#delete_event_series_submit').hide();
	
	$j.ajax({
		'url':url,
		'type':'POST',
		'data':parms,
		'dataType':'json',
		'success':successCallback
		//'dataFilter':jQuery.planscalendar.rawResponseCallback
	});

	//$j.post(url, parms, f);
}


function pending_events_toggle_events(mode) {
  for (var pending_events_id in pending_events) {
    if (mode == 1) {
      if (!document.getElementById('pending_event_approve_'+pending_events_id).checked && !document.getElementById('pending_event_delete_'+pending_events_id).checked)
        document.getElementById('pending_event_approve_'+pending_events_id).checked = true;
      else if (document.getElementById('pending_event_approve_'+pending_events_id).checked && !document.getElementById('pending_event_delete_'+pending_events_id).checked)
        document.getElementById('pending_event_approve_'+pending_events_id).checked = false;
      
    } else if (mode == 2) {
      if (!document.getElementById('pending_event_approve_'+pending_events_id).checked && !document.getElementById('pending_event_delete_'+pending_events_id).checked)
        document.getElementById('pending_event_delete_'+pending_events_id).checked = true;
      else if (document.getElementById('pending_event_delete_'+pending_events_id).checked && !document.getElementById('pending_event_approve_'+pending_events_id).checked)
        document.getElementById('pending_event_delete_'+pending_events_id).checked = false;
    } 
  }
}


function approve_pending_events_toggle() {
  var results = '';
  
  if (document.getElementById('pending_events').style.display == 'block') {
    document.getElementById('pending_events').style.display = 'none';
    return;
  }
  
  results += '<div style="text-align:right;"><img src="'+theme_url+'/graphics/green_check.gif" onclick="pending_events_toggle_events(1)"><img src="'+theme_url+'/graphics/trashcan.gif" onclick="pending_events_toggle_events(2)"/></div>'

  /*
  pending_events.sort(function(a, b) {
	  if (a.timestamp > b.timestamp) return 1;
	  if (a.timestamp < b.timestamp) return -1;
	  return 0;
  });
  */
  
  for (var pending_events_id in pending_events) {
    results += generate_pending_event(pending_events[pending_events_id]);
  }
  
  results += "<br style=\"clear:both;\">";
  results += "<a style=\"border:solid 1px #ccc;padding:4px;margin-top:5px;\" href=\"javascript:approve_pending_events_submit()\">"+get_lang('email_reminder_text5')+"</a>";
  results += "<br style=\"clear:both;\">";
  
  document.getElementById('pending_events').innerHTML = results;
  document.getElementById('pending_events').style.display = 'block';
}


function display_event(evt_id) {
	info('display_event');
	// remote event

	if (evt_id.match(/^r/)) {
		var URL_string = remote_event_details[evt_id].url;
		info_window = this.open(URL_string, "info_window", "resizable=yes,status=yes,scrollbars=yes,top="+info_window_y+",left="+info_window_x+",width=400,height=500");
		//info_window.focus();
		return;
	}

	// local event
	var event = jQuery.planscalendar.events[evt_id];

	jQuery.planscalendar.display_local_event(event);
}

jQuery.planscalendar.display_local_event = function( event ) {

	event.event_calendar_name = jQuery.planscalendar.get_cal(event.cal_ids[0]).title;

	var results = tmpl('event_details_tmpl', event);

	var f = function(event, ui) {
		$j('#event_details_dialog').dialog('destroy');
		return false;
	}


	$j('#event_details_dialog').html(results).dialog({'width':500,'position':'center', 'beforeclose': f });
	$j('#event_details_dialog').css( {'background-color':event.bgcolor});
	
	jQuery.planscalendar.insert_lang_string( $j('#event_details_dialog'), ['context_menu_edit_event','email_reminder_link'] );

	$j('#event_details_dialog .edit_event_link').click(function(e){jQuery.planscalendar.edit_event(jQuery.planscalendar.events[$j(e.originalTarget).attr('event_id')])})

	$j('#event_details_dialog .email_reminder_link').click(function(e){jQuery.planscalendar.email_reminder(jQuery.planscalendar.events[$j(e.originalTarget).attr('event_id')])})

	$j('#event_details_dialog .export_event_link').click(function(e){jQuery.planscalendar.export_event(jQuery.planscalendar.events[$j(e.originalTarget).attr('event_id')])})

}

jQuery.planscalendar.edit_event = function(event) {
	info(event);

	$j('#event_details_dialog').dialog('destroy');
	$j('#menu_tabs').tabs('select',1);
	jQuery.planscalendar.show_add_edit_event_dialog();
	jQuery.planscalendar.show_edit_event_dialog();
	jQuery.planscalendar.populate_add_edit_event_dialog(event);

}



jQuery.planscalendar.email_reminder = function(event) {
	info(event);
}

jQuery.planscalendar.export_event = function(event) {
	info(event);
}



function display_pending_event(pending_event_id) {
  var info_window_x = window_x()-info_window_width;
  var info_window_y = window_y();
  
  var URL_string = plans_url+"?view_pending_event=1&pending_event_id="+pending_event_id;
  info_window = this.open(URL_string, "info_window", "resizable=yes,status=yes,scrollbars=yes,top="+info_window_y+",left="+info_window_x+",width="+info_window_width+",height="+info_window_height);
  
  //info_window.focus();
}



function generate_pending_event(event) {
  var results = "";
  
  results += "<div style=\"text-align:right;\">";
  results += generate_list_event(event, "javascript:display_pending_event("+event.id+")");
  results +="<input name=\"pending_event_"+event.id+"\" id=\"pending_event_approve_"+event.id+"\" type=\"radio\"/><input name=\"pending_event_"+event.id+"\" id=\"pending_event_delete_"+event.id+"\" type=\"radio\"/></div>"
  
  return results;
}

function generate_list_event(event, link) {
  var results = "";
  
  var date_string;
  var weekday_string;
  var nice_start_date = nice_date(new Date(event.start), new Date(event.end));

    
  results += "<span class=\"small_note\" style=\"line-height:20px;\">"+nice_start_date;
  if (event.icon && event.icon != "blank") results += "<img src=\""+theme_url+"/icons/"+event.icon+"_16x16.gif\"/>";
  
  results += "<a href=\"javascript:display_pending_event("+event.id+")\">"+event.title+"</a>";
  results += "</span>"
  return results;

}


function nice_date(start, end, abbreviate_months, include_year) {
  var results = "";
  var separator_string = " - ";
  
  var start_display_year = (include_year || start.getUTCFullYear() != rightnow.getUTCFullYear()) ? ', '+start.getUTCFullYear() : '';
  var end_display_year = (include_year || end.getUTCFullYear() != rightnow.getUTCFullYear()) ? ', '+end.getUTCFullYear() : '';
  
  var start_display_month = (abbreviate_months) ? plans_lang['months_abv'][start.getUTCMonth()] : plans_lang['months'][start.getUTCMonth()];
  var end_display_month = (abbreviate_months) ? plans_lang['months_abv'][end.getUTCMonth()] : plans_lang['months'][end.getUTCMonth()];
  

  if (jQuery.planscalendar.date_format == 'dd/mm/yy')
  {
    if (start.getUTCMonth() == end.getUTCMonth() && start.getUTCFullYear() == end.getUTCFullYear() && start.getUTCDate() == end.getUTCDate())
    { //same year, same month, same day
      results = start.getUTCDate()+' '+start_display_month+start_display_year;
    }
    else if (start.getUTCMonth() == end.getUTCMonth() && start.getUTCFullYear() == end.getUTCFullYear())
    { //same year, same month
      results = start.getUTCDate()+separator_string+end.getUTCDate()+' '+start_display_month+start_display_year;
    }
    else if (start.getUTCFullYear() != end.getUTCFullYear())
    { //different year
      results = start.getUTCDate()+start_display_month+start_display_year+separator_string+end.getUTCDate()+end_display_month+end_display_year;
    }
    else 
    { //same year, different months
      results = start.getUTCDate()+start_display_month+separator_string+end.getUTCDate()+end_display_month+end_display_year;
    }
  }
  else
  {
    if (start.getUTCMonth() == end.getUTCMonth() && start.getUTCFullYear() == end.getUTCFullYear() && start.getUTCDate() == end.getUTCDate())
    { //same year, same month, same day
      results = start_display_month+' '+start.getUTCDate()+start_display_year;
    }
    else if (start.getUTCMonth() == end.getUTCMonth() && start.getUTCFullYear() == end.getUTCFullYear())
    { //same year, same month
      results = start_display_month+''+start.getUTCDate()+separator_string+end.getUTCDate()+start_display_year;
    }
    else if (start.getUTCFullYear() != end.getUTCFullYear())
    { //different year
      results = start_display_month+' '+start.getUTCDate()+start_display_year+separator_string+end_display_month+' '+end.getUTCDate()+end_display_year;
    }
    else 
    { //same year, different months
      results = start_display_month+' '+start.getUTCDate()+separator_string+end_display_month+' '+end.getUTCDate()+end_display_year;
    }
  
  }
  return results;
}

function nice_time(start, end, days)  {
  var start_date = new Date(start*1000);
  var end_date = new Date(end*1000);
  
  var temp = (start_date.getUTCDay() == end_date.getUTCDay()) ? '':'dna ';

  var results = '';
  results = formatDate(start_date,temp+"sh:mm ampm")+" - "+formatDate(end_date,temp+"sh:mm ampm");
  
  // if times are the same, remove the second one.
  if (end - start <=1)
  {
    results = results.replace(/s*-.+/,'');
    return results;
  }
  
  // if both times are am or pm, remove the first one (it's redundant!)
  //$results =~ s/(.*) $lang{am}(.*$lang{am}.*)/$1$2/;
  //$results =~ s/(.*) $lang{pm}(.*$lang{pm}.*)/$1$2/;
  
  var reg1 = new RegExp('(.*) am(.*am.*)');
  var reg2 = new RegExp('(.*) pm(.*pm.*)');
  results = results.replace(reg1,'$1$2');
  results = results.replace(reg2,'$1$2');
  results = results.replace(/am/,plans_lang['am']);
  results = results.replace(/pm/,plans_lang['pm']);
  
  return results;
}




function addZero(vNumber){ 
    return ((vNumber < 10) ? "0" : "") + vNumber 
} 
        
function formatDate(vDate, vFormat){
    var vDay              = addZero(vDate.getUTCDate()); 
    var vMonth            = addZero(vDate.getUTCMonth()+1); 
    var vMonthName        = plans_lang['months'][vDate.getUTCMonth()]; 
    var vMonthNameAbv     = plans_lang['months_abv'][vDate.getUTCMonth()]; 
    var vDayName          = plans_lang['day_names'][vDate.getUTCDay()]; 
    var vDayNameAbv       = plans_lang['day_names_abv'][vDate.getUTCDay()]; 
    var vYearLong         = addZero(vDate.getFullYear()); 
    var vYearShort        = addZero(vDate.getFullYear().toString().substring(3,4)); 
    var vYear             = (vFormat.indexOf("yyyy")>-1?vYearLong:vYearShort) 
    var vHour             = addZero(vDate.getUTCHours());
    var ampm              = (vHour < 12) ? 'am': 'pm';
    
    var vShortHour = vHour;
  
    if (vHour > 12)
       vShortHour -= 12;
 
    if (vShortHour == 0)
       vShortHour = 12;

    
    var vMinute           = addZero(vDate.getUTCMinutes()); 
    var vSecond           = addZero(vDate.getUTCSeconds()); 
    var vDateString       = vFormat.replace(/dd/g, vDay).replace(/MM/g, vMonth).replace(/MNA/g, vMonthNameAbv).replace(/MN/g, vMonthName).replace(/y{1,4}/g, vYear);
    vDateString           = vDateString.replace(/hh/g, vHour).replace(/sh/g, vShortHour).replace(/mm/g, vMinute).replace(/ss/g, vSecond).replace(/ampm/g, ampm);
    vDateString           = vDateString.replace(/dna/g, vDayNameAbv).replace(/dn/g, vDayName);
    return vDateString 
} 



function get_lang(key) {
  if (plans_lang[key]) return plans_lang[key];
  return '';
}


// classes

function User(i, n) {
	this.id = (i) ? i : null;        // id must be unique among users
	this.name = (n) ? n : "";
}


function Calendar(properties) {
  this.id = get_property(properties,'id',null);        // id must be unique among calendars
	this.title = get_property(properties,'title','');
	this.local_background_calendars_string = get_property(properties,'local_background_calendars','');
	this.local_background_calendars = this.local_background_calendars_string.split(',');
  if (!this.local_background_calendars) this.local_background_calendars = new Array();
}

function Event(properties) {
  this.id = get_property(properties,'id',null);        // id must be unique among events
	this.title = get_property(properties,'title','');
	this.details = get_property(properties,'details','');
	this.details_url = get_property(properties,'details_url',false);
	this.icon = get_property(properties,'icon','');
	this.bgcolor = get_property(properties,'bgcolor','');
	this.unit_number = get_property(properties,'unit_number','');
  this.start = get_property(properties,'start','');
  this.end = get_property(properties,'end','');
  this.timestamp = get_property(properties,'timestamp',0);
  this.days = get_property(properties,'days',1);
  this.all_day_event = get_property(properties,'all_day_event',false);
  this.no_end_time = get_property(properties,'no_end_time',false);
  this.cal_ids_string = get_property(properties,'cal_ids','');
  this.cal_ids = this.cal_ids_string.split(',');
}




function partial (fn, scope) {
    var scope = scope || window;
    var args = [];
    for (var i=2, len = arguments.length; i < len; ++i) {
		//info('pushing bind time arg:');
		//info(arguments[i]);
        args.push(arguments[i]);
    };
	
    return function() {
		args2 = [];
	
		for (var i=0, len = args.length; i < len; ++i) {
			//info('pushing run time arg:');
			//info(args[i]);
			args2.push(args[i]);
		}
		
		for (var i=0, len = arguments.length; i < len; ++i) {
			//info('pushing run time arg:');
			//info(arguments[i]);
			args2.push(arguments[i]);
		};

		//info('arguments:');
		//info(args2);
	    fn.apply(scope, args2);
		args2 = [];
    };
}

// Simple JavaScript Templating
// John Resig - http://ejohn.org/ - MIT Licensed
(function(){
  var cache = {};
 
  this.tmpl = function tmpl(str, data){
    // Figure out if we're getting a template, or if we need to
    // load the template - and be sure to cache the result.
    var fn = !/\W/.test(str) ?
      cache[str] = cache[str] ||
        tmpl(document.getElementById(str).innerHTML) :
     
      // Generate a reusable function that will serve as a template
      // generator (and which will be cached).
      new Function("obj",
        "var p=[],print=function(){p.push.apply(p,arguments);};" +
       
        // Introduce the data as local variables using with(){}
        "with(obj){p.push('" +
       
        // Convert the template into pure JavaScript
        str
          .replace(/[\r\t\n]/g, " ")
          .split("<%").join("\t")
          .replace(/((^|%>)[^\t]*)'/g, "$1\r")
          .replace(/\t=(.*?)%>/g, "',$1,'")
          .split("\t").join("');")
          .split("%>").join("p.push('")
          .split("\r").join("\\'")
      + "');}return p.join('');");
   
    // Provide some basic currying to the user
    return data ? fn( data ) : fn;
  };
})();

/**
 * Cookie plugin
 *
 * Copyright (c) 2006 Klaus Hartl (stilbuero.de)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 */

/**
 * Create a cookie with the given name and value and other optional parameters.
 *
 * @example $.cookie('the_cookie', 'the_value');
 * @desc Set the value of a cookie.
 * @example $.cookie('the_cookie', 'the_value', { expires: 7, path: '/', domain: 'jquery.com', secure: true });
 * @desc Create a cookie with all available options.
 * @example $.cookie('the_cookie', 'the_value');
 * @desc Create a session cookie.
 * @example $.cookie('the_cookie', null);
 * @desc Delete a cookie by passing null as value. Keep in mind that you have to use the same path and domain
 *       used when the cookie was set.
 *
 * @param String name The name of the cookie.
 * @param String value The value of the cookie.
 * @param Object options An object literal containing key/value pairs to provide optional cookie attributes.
 * @option Number|Date expires Either an integer specifying the expiration date from now on in days or a Date object.
 *                             If a negative value is specified (e.g. a date in the past), the cookie will be deleted.
 *                             If set to null or omitted, the cookie will be a session cookie and will not be retained
 *                             when the the browser exits.
 * @option String path The value of the path atribute of the cookie (default: path of page that created the cookie).
 * @option String domain The value of the domain attribute of the cookie (default: domain of page that created the cookie).
 * @option Boolean secure If true, the secure attribute of the cookie will be set and the cookie transmission will
 *                        require a secure protocol (like HTTPS).
 * @type undefined
 *
 * @name $.cookie
 * @cat Plugins/Cookie
 * @author Klaus Hartl/klaus.hartl@stilbuero.de
 */

/**
 * Get the value of a cookie with the given name.
 *
 * @example $.cookie('the_cookie');
 * @desc Get the value of a cookie.
 *
 * @param String name The name of the cookie.
 * @return The value of the cookie.
 * @type String
 *
 * @name $.cookie
 * @cat Plugins/Cookie
 * @author Klaus Hartl/klaus.hartl@stilbuero.de
 */
jQuery.cookie = function(name, value, options) {
    if (typeof value != 'undefined') { // name and value given, set cookie
        options = options || {};
        if (value === null) {
            value = '';
            options.expires = -1;
        }
        var expires = '';
        if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
            var date;
            if (typeof options.expires == 'number') {
                date = new Date();
                date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
            } else {
                date = options.expires;
            }
            expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
        }
        // CAUTION: Needed to parenthesize options.path and options.domain
        // in the following expressions, otherwise they evaluate to undefined
        // in the packed version for some reason...
        var path = options.path ? '; path=' + (options.path) : '';
        var domain = options.domain ? '; domain=' + (options.domain) : '';
        var secure = options.secure ? '; secure' : '';
        document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
    } else { // only name given, get cookie
        var cookieValue = null;
        if (document.cookie && document.cookie != '') {
            var cookies = document.cookie.split(';');
            for (var i = 0; i < cookies.length; i++) {
                var cookie = jQuery.trim(cookies[i]);
                // Does this cookie string begin with the name we want?
                if (cookie.substring(0, name.length + 1) == (name + '=')) {
                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                    break;
                }
            }
        }
        return cookieValue;
    }
};

